local WaterMill = ...

WaterMill:registerEnumValue ("BUILDING_PART_TYPE", "EXTENSION")

-- Particle system
WaterMill:dofile("scripts/flow.lua")

-- Register all water mill building parts and their properties
WaterMill:dofile("scripts/buildings.lua")

WaterMill:register({
    Id = WaterMillPrefix .. "_MONUMENT",
    DataType = "BUILDING",
    AssetCoreBuildingPart = WaterMillPrefix .. "_CORE_BUILDING_PART",
    Name = WaterMillPrefix .. "_SET_NAME",
    Description = WaterMillPrefix .. "_SET_DESC",
    BuildingType = "MONUMENT",
    BuildingPartSetList = {
        {
            Name = "PRODUCTION_CORE",
	    BuildingPartList = {
		WaterMillPrefix .. "_CORE_FLOUR_PART",
		WaterMillPrefix .. "_CORE_TEXTILE_PART",
		WaterMillPrefix .. "_CORE_TEXTILE_FLAX_PART",
		WaterMillPrefix .. "_CORE_PLANKS_PART"
            }
        },
        { 
            Name = "WHEEL",
	    BuildingPartList = {
		WaterMillPrefix .. "_EXTENSION_LEFT_BANK_PART",
		WaterMillPrefix .. "_EXTENSION_RIGHT_BANK_PART"
	    }
        }
    },
    MaterialSetList = {
            {
                SetName = WaterMillPrefix .. "_YELLOW_ROOF", -- default materials
                MaterialList = {
                    WaterMillPrefix .. "_YELLOW_ROOF_MATERIAL"
                }           
            },
            {
                SetName = WaterMillPrefix .. "_GREEN_ROOF", -- default materials
                MaterialList = {
                    WaterMillPrefix .. "_GREEN_ROOF_MATERIAL"
                }           
            },
            {
                SetName = WaterMillPrefix .. "_BROWN_ROOF", -- default materials
                MaterialList = {
                    WaterMillPrefix .. "_BROWN_ROOF_MATERIAL"
                }           
            },
            {
                SetName = WaterMillPrefix .. "_BLUE_ROOF", -- default materials
                MaterialList = {
                    WaterMillPrefix .. "_BLUE_ROOF_MATERIAL"
                }           
            },
            {
                SetName = WaterMillPrefix .. "_RED_ROOF", -- default materials
                MaterialList = {
                    WaterMillPrefix .. "_RED_ROOF_MATERIAL"
                }           
            }
    },
    RequiredPartList = {
		-- Necessarily a list of 'MONUMENT_REQUIRED_PART_PAIR', no need to specify the DataType of each element of the list
		{ Category = "CORE", Quantity = 1 },
		{ Category = "EXTENSION", Quantity = 1 }
    },
    IsEditable = true
})